﻿using UnityEngine;
using System.Collections;

public class enemy : MonoBehaviour {

	private Vector3 target;
	private bool moving;
	public GameObject player, hitMark;

	public int startHealth, health, damage;
	public bool passive;

	// Use this for initialization
	void Start () {
		player = GameObject.Find("Player");
		target = transform.position;
	}
	
	// Update is called once per frame
	void Update () {
		transform.position = Vector3.Lerp(transform.position, target, 0.2f);
	}

	void OnEnable(){
		playerMovement.turn += chooseAction;
	}

	void OnDisable(){
		playerMovement.turn -= chooseAction;
	}

	void chooseAction(){
		if(!passive){
			if(lookForPlayer())
				moveTowardPlayer();
			else moveRandom();
		}
		else
			moveRandom(); //if cannot see player walk random
	}

	void OnDrawGizmos(){
		Vector3 separation = player.transform.position-transform.position;
//		print(separation);
		Vector3 cursor = transform.position;
		Vector3 cursor2 = transform.position;
		float xRatio, yRatio;
		float yBuildUp=0;
		float yBuildUp2=1;
		bool check1, check2;
		check1 = check2 = false;
		xRatio = separation.x/separation.y;
		yRatio = separation.y/separation.x;
//		else ratio = separation.x/separation.y;
//		print(xRatio + " " + yRatio);

		if(Mathf.Abs(separation.x)<=0.01f) yBuildUp2 = 15;

		Gizmos.color = Color.green;
		if(!lookForPlayer()) Gizmos.color = Color.red;

		for(int i = 0; i<15; i++){
//			yBuildUp += Mathf.Abs(yRatio);
			if(!check1){
				if(yBuildUp>1){
					yBuildUp-=1;
					cursor+=new Vector3 (0, (separation.y>0)?1:-1);
				}
				else{
					yBuildUp += Mathf.Abs(yRatio);
					cursor+=new Vector3 ((separation.x>0)?1:-1, 0);
				}
			}
			if(!check2){
				if(yBuildUp2>=1){
					yBuildUp2-=1;
					cursor2+=new Vector3 (0, (separation.y>0)?1:-1);
				}
				else{
					yBuildUp2 += Mathf.Abs(yRatio);
					cursor2+=new Vector3 ((separation.x>0)?1:-1, 0);
				}
			}
			check1 = canSee(cursor, "Wall");
			check2 = canSee(cursor2, "Wall");
//			if(Mathf.Abs(separation.y)>Mathf.Abs(separation.x)){
//				print("y is bigger, ratio: " + yRatio);
//				if((i)%yRatio == 0)
//					cursor+=new Vector3 ((separation.x>0)?1:-1, 0);	
//				else
//					cursor+=new Vector3 (0, (separation.y>0)?1:-1);
//			}
//			else{
//				print("x is bigger, ratio: " + xRatio);
//				if((i)%xRatio == 0)
//					cursor+=new Vector3 (0, (separation.y>0)?1:-1);
//				else
//					cursor+=new Vector3 ((separation.x>0)?1:-1, 0);
//			}
//			canSee(cursor);
			Gizmos.DrawWireCube(cursor, new Vector3(1, 1, 1));
			Gizmos.DrawWireCube(cursor2, new Vector3(1, 1, 1));
		}
	}

	void moveRandom(){
		bool valid = false;
		while(!valid){
			switch(Mathf.FloorToInt(Random.value*4)){
			case 0:
				valid = Go(1, 0);
				break;
			case 1:
				valid = Go(-1, 0);
				break;
			case 2:
				valid = Go(0, 1);
				break;
			case 3:
				valid = Go(0, -1);
				break;
			}
			valid = true;
		}
	}

	void moveTowardPlayer(){
		bool valid;
		Vector3 separation = player.transform.position-transform.position;
		if(Mathf.Abs(separation.x)>=Mathf.Abs(separation.y)){
			valid = Go((separation.x>0)?1:-1, 0);
			if(valid == false)
				Go(0, (separation.y>0)?1:-1);
		}
		else if(Mathf.Abs(separation.x)<Mathf.Abs(separation.y)){
			valid = Go(0, (separation.y>0)?1:-1);
			if(valid == false)
				Go((separation.x>0)?1:-1, 0);
		}
	}

	bool Go(float xCoord, float yCoord){
		if(canSee(transform.position+new Vector3(xCoord, yCoord), "Wall") || canSee(transform.position+new Vector3(xCoord, yCoord), "Enemy")){
			return false;
		}
		else if(canSee(transform.position+new Vector3(xCoord, yCoord), "Player")){
			player.GetComponent<playerMovement>().takeDamage(damage);
			return true;
		}
		else if(target+new Vector3(xCoord, yCoord) == player.GetComponent<playerMovement>().target){
			player.GetComponent<playerMovement>().takeDamage(damage);
			return true;
		}
		else {
			target += new Vector3(xCoord, yCoord);
			return true;
		}
	}

	public void takeDamage(int amount){
		health-=amount;
		GameObject temp = (GameObject)Instantiate(hitMark, transform.position+Vector3.back, Quaternion.identity);
		temp.GetComponent<hitIndication>().damage = amount;
		temp.GetComponent<hitIndication>().crit = true;
		temp.GetComponent<hitIndication>().textColor = new Color32(90, 220, 226, 255);
		if(health<=0)
			die();
	}

	void die(){
		theAllSeeingScript gods = GameObject.Find("theRNGgods").GetComponent<theAllSeeingScript>();
		Destroy(this.gameObject);
		if(!passive)
			gods.karma +=10;
		else{
			gods.health +=5;
			gods.luck +=5;
			gods.karma -=10;
		}
	}

	bool lookForPlayer(){
		bool seesPlayer = false;
		Vector3 separation = player.transform.position-transform.position;
		Vector3 cursor = transform.position;
		Vector3 cursor2 = transform.position;
		bool check1, check2;
		check1 = check2 = false;
		float xRatio, yRatio;
		float yBuildUp=0;
		float yBuildUp2=1;
		yRatio = separation.y/separation.x;
		if(Mathf.Abs(separation.x)<=0.01f) yBuildUp2 = 15;

		for(int i = 0; i<15; i++){
			if(!check1){
				if(yBuildUp>1){
					yBuildUp-=1;
					cursor+=new Vector3 (0, (separation.y>0)?1:-1);
				}
				else{
					yBuildUp += Mathf.Abs(yRatio);
					cursor+=new Vector3 ((separation.x>0)?1:-1, 0);
				}
			}
			if(!check2){
				if(yBuildUp2>1){
					yBuildUp2-=1;
					cursor2+=new Vector3 (0, (separation.y>0)?1:-1);
				}
				else{
					yBuildUp2 += Mathf.Abs(yRatio);
					cursor2+=new Vector3 ((separation.x>0)?1:-1, 0);
				}
			}
			check1 = canSee(cursor, "Wall");
			check2 = canSee(cursor2, "Wall");
			if(canSee(cursor, "Player") || canSee(cursor2, "Player"))
				return true;
		}
		return false;
	}

	bool canSee(Vector3 checkHere, string checkTag){
		Debug.DrawLine(checkHere+new Vector3(0, 0, 1), checkHere+new Vector3(0, 0, -1));
		RaycastHit hit;
		if(Physics.Raycast(checkHere+new Vector3(0, 0, -1), new Vector3(0, 0, 1), out hit)){
			if(hit.collider.tag == checkTag){
				//print("At coordintes " + checkHere + " there is a wall.");
				return true;
			}
		}
		return false;
	}

	int RoundToFurthestFromZero(float number){
		int output;
		if(number<0){
			output = Mathf.FloorToInt(number);
		}
		else{
			output = Mathf.CeilToInt(number);
		}
		return output;
	}
}