﻿using UnityEngine;
using System.Collections;

public class playerMovement : MonoBehaviour {

	public delegate void ADelegate();
	public static event ADelegate turn;

	public Vector3 target;
	private bool moving;

	public GameObject[] nearEnemies;
	private bool enemySelect, inCombat;
	public GameObject cursorPrefab, fightPanel, confirmPanel, altarPanel;
	private GameObject enemyCursor;
	private int enemyIndex;

	public GameObject hitMark;
	public theAllSeeingScript gods;

	void Start () {
		nearEnemies = new GameObject[4];
		gods = GameObject.Find("theRNGgods").GetComponent<theAllSeeingScript>();
		target = transform.position;
		moving = false;
		enemySelect = false;
	}
		
	void Update () {
		if(enemySelect){
			if(Input.GetKeyDown(KeyCode.W)){
				enemyIndex--;
				if(enemyIndex<=-1)
					enemyIndex=3;
				if(nearEnemies[enemyIndex]==null){
					while(nearEnemies[enemyIndex]==null){
						enemyIndex--;
						if(enemyIndex<=-1)
							enemyIndex=3;
					}
				}
			}
			if(Input.GetKeyDown(KeyCode.S)){
				enemyIndex++;
				if(enemyIndex>=4)
					enemyIndex=0;
				if(nearEnemies[enemyIndex]==null){
					while(nearEnemies[enemyIndex]==null){
						enemyIndex++;
						if(enemyIndex>=4)
							enemyIndex=0;
					}
				}
			}
			enemyCursor.transform.position = nearEnemies[enemyIndex].transform.position;
			if(Input.GetKeyDown(KeyCode.Return)){
				hit();
				enemySelect = false;
				confirmPanel.SetActive(false);
				Destroy(enemyCursor);
			}
			if(Input.GetKeyDown(KeyCode.Escape)){
				confirmPanel.SetActive(false);
				fightPanel.SetActive(true);
				enemySelect = false;
				Destroy(enemyCursor);
			}
		}
		else if(inCombat){
			if(Input.GetKeyDown(KeyCode.Escape)){
				endCombat();
			}
		}
		else if(!moving && !inCombat){
			if(Input.GetKey(KeyCode.W)){
				Go(0, 1);
			}
			if(Input.GetKey(KeyCode.A)){
				Go(-1, 0);
			}
			if(Input.GetKey(KeyCode.S)){
				Go(0, -1);
			}
			if(Input.GetKey(KeyCode.D)){
				Go(1, 0);
			}
		}

		transform.position = Vector3.Lerp(transform.position, target, 0.2f);
		if(Mathf.Abs(transform.position.x-target.x)<0.05f && Mathf.Abs(transform.position.y-target.y)<0.05f) moving = false;
	}

	void OnEnable(){
		turn += endCombat;
	}

	void OnDisable(){
		turn -= endCombat;
	}

	void endCombat(){
		fightPanel.SetActive(false);
		altarPanel.SetActive(false);
		inCombat = false;
	}
		
	void Go(float xCoord, float yCoord){
		if(!moving){
			if(canSee(transform.position+new Vector3(xCoord, yCoord), "Enemy")){
				fightPanel.SetActive(true);
				inCombat = true;
			}
			else if(canSee(transform.position+new Vector3(xCoord, yCoord), "Wall")){
				if(findsAt(transform.position+new Vector3(xCoord, yCoord), "Wall").GetComponent<altar>()){
					if(!findsAt(transform.position+new Vector3(xCoord, yCoord), "Wall").GetComponent<altar>().broken){
						findsAt(transform.position+new Vector3(xCoord, yCoord), "Wall").GetComponent<altar>().beingUsed = true;
						altarPanel.SetActive(true);
						inCombat = true;
					}
				}
			}
			else if(!canSee(transform.position+new Vector3(xCoord, yCoord), "Wall")){
				target += new Vector3(xCoord, yCoord);
				moving = true;
				turn();
			}
		}
	}

	void getEnemies(){
		if(findsAt(transform.position+Vector3.up, "Enemy")!=null)
			nearEnemies[0]=findsAt(transform.position+Vector3.up, "Enemy");
		else
			nearEnemies[0]=null;
		if(findsAt(transform.position+Vector3.right, "Enemy")!=null)
			nearEnemies[1]=findsAt(transform.position+Vector3.right, "Enemy");
		else
			nearEnemies[0]=null;
		if(findsAt(transform.position+Vector3.down, "Enemy")!=null)
			nearEnemies[2]=findsAt(transform.position+Vector3.down, "Enemy");
		else
			nearEnemies[0]=null;
		if(findsAt(transform.position+Vector3.left, "Enemy")!=null)
			nearEnemies[3]=findsAt(transform.position+Vector3.left, "Enemy");
		else
			nearEnemies[0]=null;
	}

	GameObject findsAt(Vector3 checkHere, string checkTag){
		Debug.DrawLine(checkHere+new Vector3(0, 0, 1), checkHere+new Vector3(0, 0, -1));
		RaycastHit hit;
		if(Physics.Raycast(checkHere+new Vector3(0, 0, -1), new Vector3(0, 0, 1), out hit)){
			if(hit.collider.tag == checkTag){
				return hit.collider.gameObject;
			}
		}
		return null;
	}

	bool canSee(Vector3 checkHere, string checkTag){
		Debug.DrawLine(checkHere+new Vector3(0, 0, 1), checkHere+new Vector3(0, 0, -1));
		RaycastHit hit;
		if(Physics.Raycast(checkHere+new Vector3(0, 0, -1), new Vector3(0, 0, 1), out hit)){
			if(hit.collider.tag == checkTag){
				return true;
			}
		}
		return false;
	}

	public void attack(){
		print("going to attack");
		getEnemies();
		confirmPanel.gameObject.SetActive(true);
		fightPanel.gameObject.SetActive(false);
		enemyIndex = 0;
		while(nearEnemies[enemyIndex]==null){
			enemyIndex++;
		}
		enemyCursor = Instantiate(cursorPrefab, nearEnemies[enemyIndex].transform.position, Quaternion.identity) as GameObject;
		enemySelect = true;
	}

	public void hit(){
		float rand = Random.Range(0, 100);
		if(rand<gods.luck+gods.luckBoost){
			if(rand>70){
				nearEnemies[enemyIndex].GetComponent<enemy>().takeDamage(gods.attack*2);
			}
			else
				nearEnemies[enemyIndex].GetComponent<enemy>().takeDamage(gods.attack);
		}
		gods.luckBoost = 0;
		turn();
	}
	public void pray(){
		gods.luckBoost=gods.karma;
		gods.karma-=2;
		turn();
	}
	public void sacrifice(){
		if(gods.karma>0)
			gods.karma-=10;
		if(gods.karma<0)
			gods.karma = 0;
		takeDamage(1);
		gods.luckBoost=100;
		turn();
	}

	public void worship(){
		if(gods.karma<70)
			gods.karma+=5;
		turn();
	}

	public void repent(){
		if(gods.karma<30)
			gods.karma = 50;
		else
			gods.karma+=20;
		turn();
	}

	public void ask(){
		gods.health+=10;
		if(gods.health>gods.initialHealth)
			gods.health = gods.initialHealth;
		turn();
	}

	public void curse(){
		gods.karma = 0;
		turn();
	}

	public void takeDamage(int damage){
		gods.health-=damage;
		if(gods.health<0)
			gods.health = 0;
		GameObject temp = (GameObject)Instantiate(hitMark, transform.position+Vector3.back, Quaternion.identity);
		temp.GetComponent<hitIndication>().damage = damage;
		temp.GetComponent<hitIndication>().textColor = new Color32(242, 25, 25, 255); //red
	}
}